// c / d - blech 4


$fn = 16;

cellRadius = 1.0;

cellSize = 5.0;

layerHeight = 2.0;

pinOffset = 0.15;

use <basics.scad>

blechWidth  = cellSize * 7;
blechHeight = cellSize * 2.9; // 2.75

module efBlech() {
    difference() {
        translate([0, 0, 0]) cube([blechWidth, blechHeight, layerHeight]);
        translate([cellSize /2 , cellSize + 1.65, -0.01]) dualXCell(layerHeight + 0.02);
        translate([cellSize * 4.5, cellSize + 1.65, -0.01]) dualXCell(layerHeight + 0.02);
        translate([cellSize * 1, 0.15-0.01, 0]) notch();
        translate([cellSize * 5, 0.15-0.01, 0]) notch();
    }
    translate([0, blechHeight - layerHeight + 0.2, layerHeight]) cube([blechWidth, layerHeight - 0.2, layerHeight]);
}

module dualXCell(height = layerHeight) {
    hull() {
        translate([0       , 0, 0]) cell(height);
        translate([cellSize, 0, 0]) cell(height);
    }
}

module notch() {
    translate([0, 0, -0.01]) cell(layerHeight + 0.02);
    translate([0, -0.15, -0.01]) cube([cellSize, cellSize /2, layerHeight + 0.02]);
}

module roundedNotch() {
    difference() {
        union() {
            translate([0, 0, -0.01])  cell(layerHeight + 0.02);
            translate([-cellSize / 2, 0, -0.01]) cube([cellSize * 2, cellSize / 2, layerHeight + 0.02]);
        }
        translate([-cellSize, -0.01, -0.1]) cell(layerHeight + 0.4);
        translate([ cellSize, -0.01, -0.1]) cell(layerHeight + 0.4);
       
    }
}

efBlech();

//translate([0, -20, 0]) roundedNotch();

//translate([0, -20, 0]) roundedNotch();