// g - Festblech 5

$fn = 16;

cellRadius = 1.0;

cellSize = 5.0;

layerHeight = 2.0;

pinOffset = 0.15;

stiftDiameter = 4.5;

use <basics.scad>

blechWidth = cellSize * 8;
blechHeight = cellSize * 6;

module festBlech() {
    difference() {
        union() {
            translate([0, 0, 0]) cube([blechWidth, blechHeight, layerHeight]);
            // a-b guide / c-d support
            translate([cellSize, cellSize/2, layerHeight]) hexHCell();
//            translate([cellSize * 5, cellSize/2, layerHeight]) dualHCell();
            translate([cellSize, cellSize * 4.5, layerHeight]) hexHCell();
//            translate([cellSize * 5, cellSize * 4.5, layerHeight]) dualHCell();
            // pins lower half
            translate([cellSize * 2, cellSize, layerHeight * 2])     stift(layerHeight * 3);
            translate([cellSize * 6, cellSize, layerHeight * 2])     stift(layerHeight * 3);
            translate([cellSize * 2, cellSize * 5, layerHeight * 2]) stift(layerHeight * 3);
            translate([cellSize * 6, cellSize * 5, layerHeight * 2]) stift(layerHeight * 3);
       }
        // stift holes
        translate([cellSize, cellSize * 2, -0.1])     fourCell();
        translate([cellSize * 5, cellSize * 2, -0.1]) fourCell();
        // corner holes for base blech
        translate([cellSize/2, cellSize/2, -0.1])                            pin();
        translate([blechWidth - cellSize/2, cellSize/2, -0.1])               pin();
        translate([cellSize/2, blechHeight - cellSize/2, -0.1])              pin();
        translate([blechWidth - cellSize/2, blechHeight - cellSize/2, -0.1]) pin();
    }
    // side guides for c & d
    translate([0, -cellRadius * 2, 0]) cube([blechWidth, layerHeight, layerHeight * 3]);
    translate([0, blechHeight, 0]) cube([blechWidth, layerHeight, layerHeight * 3]);
    // middle guides for e & f
    translate([blechWidth / 2 - cellSize / 2, -layerHeight, layerHeight * 3]) 
        cube([cellSize, layerHeight, layerHeight]);
    translate([blechWidth / 2 - cellSize / 2, blechHeight, layerHeight * 3]) 
        cube([cellSize, layerHeight, layerHeight]);
    // corner guides for e & f
    translate([0, -layerHeight, layerHeight * 3]) 
        cube([cellSize / 2, layerHeight, layerHeight]);
    translate([blechWidth - cellSize / 2, -layerHeight, layerHeight * 3]) 
        cube([cellSize / 2, layerHeight, layerHeight]);
    translate([0, blechHeight, layerHeight * 3]) 
        cube([cellSize / 2, layerHeight, layerHeight]);
    translate([blechWidth - cellSize / 2, blechHeight, layerHeight * 3]) 
        cube([cellSize / 2, layerHeight, layerHeight]);
    // corner stifts
    translate([1,              -1.0,            layerHeight * 3]) pin(pinOffset);
    translate([1,              -1.0,            layerHeight * 4]) pin(pinOffset);
    translate([blechWidth - 1, -1.0,            layerHeight * 3]) pin(pinOffset);
    translate([blechWidth - 1, -1.0,            layerHeight * 4]) pin(pinOffset);
    translate([1,              blechHeight + 1, layerHeight * 3]) pin(pinOffset);
    translate([1,              blechHeight + 1, layerHeight * 4]) pin(pinOffset);
    translate([blechWidth - 1, blechHeight + 1, layerHeight * 3]) pin(pinOffset);
    translate([blechWidth - 1, blechHeight + 1, layerHeight * 4]) pin(pinOffset);
 
}

module dualHCell() {
    hull() {
        translate([0,        0, 0]) cell();
        translate([cellSize, 0, 0]) cell();
    }
}

module hexHCell() {
    hull() {
        translate([0           , 0, 0]) cell();
        translate([cellSize * 5, 0, 0]) cell();
    }
}

module fourCell() {
    hull() {
        translate([0       , 0       , 0]) cell(layerHeight + 0.2);
        translate([cellSize, 0       , 0]) cell(layerHeight + 0.2);
        translate([0       , cellSize, 0]) cell(layerHeight + 0.2);
        translate([cellSize, cellSize, 0]) cell(layerHeight + 0.2);
    }
}

module stift(height = layerHeight) {
    translate([0, 0, 0]) cylinder(h = height, d = stiftDiameter);
}

festBlech();